Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_POA Class Reference

Implementation of the PortableServer::POA interface. More...

`#include <POA.h>`

Inheritance diagram for TAO_POA:

[legend]
Collaboration diagram for TAO_POA:

[legend]
List of all members.

## Public Types
typedef ACE_CString | String
enum | { TAO_OBJECTKEY_PREFIX_SIZE = 4 }
## Public Methods
virtual TAO_POA * | _tao_poa_downcast (void)
PortableServer::POA_ptr | create_POA (const char *adapter_name, PortableServer::POAManager_ptr poa_manager, const CORBA::PolicyList &policies ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)
PortableServer::POA_ptr | find_POA (const char *adapter_name, CORBA::Boolean activate_it ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::AdapterNonExistent)
void | destroy (CORBA::Boolean etherealize_objects, CORBA::Boolean wait_for_completion ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::ThreadPolicy_ptr | create_thread_policy (PortableServer::ThreadPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::LifespanPolicy_ptr | create_lifespan_policy (PortableServer::LifespanPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::IdUniquenessPolicy_ptr | create_id_uniqueness_policy (PortableServer::IdUniquenessPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::IdAssignmentPolicy_ptr | create_id_assignment_policy (PortableServer::IdAssignmentPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::ImplicitActivationPolicy_ptr | create_implicit_activation_policy (PortableServer::ImplicitActivationPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::ServantRetentionPolicy_ptr | create_servant_retention_policy (PortableServer::ServantRetentionPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::RequestProcessingPolicy_ptr | create_request_processing_policy (PortableServer::RequestProcessingPolicyValue value ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
char * | the_name (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::POA_ptr | the_parent (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::POAList * | the_children (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::POAManager_ptr | the_POAManager (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableInterceptor::AdapterManagerId | get_manager_id (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException)
PortableInterceptor::AdapterName * | adapter_name (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException)
PortableInterceptor::ObjectReferenceTemplate * | get_adapter_template (void)
| Accessor methods to ObjectReferenceTemplate.
void | set_adapter_template (PortableInterceptor::ObjectReferenceTemplate *object_ref_template ACE_ENV_ARG_DECL)
PortableInterceptor::ObjectReferenceFactory * | get_obj_ref_factory (void)
| Accessor methods to PortableInterceptor::ObjectReferenceFactory.
void | set_obj_ref_factory (PortableInterceptor::ObjectReferenceFactory *current_factory ACE_ENV_ARG_DECL)
void | save_ior_component (const IOP::TaggedComponent &component ACE_ENV_ARG_DECL)
void | save_ior_component_and_profile_id (const IOP::TaggedComponent &component, IOP::ProfileId profile_id ACE_ENV_ARG_DECL)
PortableServer::AdapterActivator_ptr | the_activator (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
void | the_activator (PortableServer::AdapterActivator_ptr adapter_activator ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
PortableServer::ServantManager_ptr | get_servant_manager (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
void | set_servant_manager (PortableServer::ServantManager_ptr imgr ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
PortableServer::Servant | get_servant (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::NoServant, PortableServer::POA::WrongPolicy)
void | set_servant (PortableServer::Servant servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | activate_object (PortableServer::Servant p_servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::WrongPolicy)
void | activate_object_with_id (const PortableServer::ObjectId &id, PortableServer::Servant p_servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::ObjectAlreadyActive, PortableServer::POA::WrongPolicy)
void | deactivate_object (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | create_reference (const char *intf ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | create_reference_with_id (const PortableServer::ObjectId &oid, const char *intf ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | servant_to_id (PortableServer::Servant p_servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | servant_to_reference (PortableServer::Servant p_servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
PortableServer::Servant | reference_to_servant (CORBA::Object_ptr reference ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | reference_to_id (CORBA::Object_ptr reference ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)
PortableServer::Servant | id_to_servant (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | id_to_reference (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
CORBA::OctetSeq * | id (ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
virtual PortableServer::ObjectId * | create_id_for_reference (CORBA::Object_ptr the_ref ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw ( CORBA::SystemException, PortableServer::NotAGroupObject )
virtual PortableServer::IDs * | reference_to_ids (CORBA::Object_ptr the_ref ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw ( CORBA::SystemException, PortableServer::NotAGroupObject )
virtual void | associate_reference_with_id (CORBA::Object_ptr ref, const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw ( CORBA::SystemException, PortableServer::NotAGroupObject )
virtual void | disassociate_reference_with_id (CORBA::Object_ptr ref, const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw ( CORBA::SystemException, PortableServer::NotAGroupObject )
TAO_POA_Policy_Set & | policies (void)
| Accessor for POA policies.
TAO_POA_Cached_Policies & | cached_policies (void)
| Accessor for cached POA policies.
virtual CORBA::PolicyList * | client_exposed_policies (CORBA::Short object_priority ACE_ENV_ARG_DECL)
| TAO_POA (const String &name, TAO_POA_Manager &poa_manager, const TAO_POA_Policy_Set &policies, TAO_POA *parent, ACE_Lock &lock, TAO_SYNCH_MUTEX &thread_lock, TAO_ORB_Core &orb_core, TAO_Object_Adapter *object_adapter ACE_ENV_ARG_DECL)
virtual | ~TAO_POA (void)
const TAO_Object_Adapter::poa_name & | folded_name (void) const
const TAO_Object_Adapter::poa_name & | system_name (void) const
TAO_ORB_Core & | orb_core (void) const
CORBA::Boolean | cleanup_in_progress (void)
TAO_Object_Adapter & | object_adapter (void)
ACE_Lock & | lock (void)
TAO_Stub * | key_to_stub (const TAO::ObjectKey &key, const char *type_id, CORBA::Short priority ACE_ENV_ARG_DECL)
PortableServer::ThreadPolicyValue | thread_policy (void) const
| Accessor for the current thread policy of this POA.
PortableInterceptor::AdapterState | get_adapter_state (ACE_ENV_SINGLE_ARG_DECL)
| Accessor methods to POA state.
virtual void * | thread_pool (void) const
virtual CORBA::Policy * | server_protocol (void)
CORBA::ULong | outstanding_requests (void) const
const ACE_CString & | name (void) const
TAO_Active_Object_Map & | active_object_map (void) const
CORBA::Boolean | waiting_destruction (void) const
## Static Public Methods
char * | ObjectId_to_string (const PortableServer::ObjectId &id)
CORBA::WChar * | ObjectId_to_wstring (const PortableServer::ObjectId &id)
PortableServer::ObjectId * | string_to_ObjectId (const char *id)
PortableServer::ObjectId * | string_to_ObjectId (const char *string, int size)
PortableServer::ObjectId * | wstring_to_ObjectId (const CORBA::WChar *id)
char | name_separator (void)
CORBA::ULong | name_separator_length (void)
void | check_for_valid_wait_for_completions (const TAO_ORB_Core &orb_core, CORBA::Boolean wait_for_completion ACE_ENV_ARG_DECL)
int | parse_ir_object_key (const TAO::ObjectKey &object_key, PortableServer::ObjectId &user_id)
## Static Public Attributes
CORBA::Octet | objectkey_prefix [TAO_OBJECTKEY_PREFIX_SIZE]
## Protected Types
typedef ACE_Hash_Map_Manager_Ex< ACE_CString, TAO_POA *, ACE_Hash< ACE_CString >, ACE_Equal_To< ACE_CString >, ACE_Null_Mutex > | CHILDREN
## Protected Methods
virtual TAO_POA * | new_POA (const String &name, TAO_POA_Manager &poa_manager, const TAO_POA_Policy_Set &policies, TAO_POA *parent, ACE_Lock &lock, TAO_SYNCH_MUTEX &thread_lock, TAO_ORB_Core &orb_core, TAO_Object_Adapter *object_adapter ACE_ENV_ARG_DECL)
| Template method for creating new POA's of this type.
PortableServer::POA_ptr | create_POA_i (const char *adapter_name, PortableServer::POAManager_ptr poa_manager, const CORBA::PolicyList &policies ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)
TAO_POA * | create_POA_i (const String &adapter_name, TAO_POA_Manager &poa_manager, const TAO_POA_Policy_Set &policies ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)
TAO_POA * | find_POA_i (const ACE_CString &child_name, CORBA::Boolean activate_it ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::AdapterNonExistent)
void | destroy_i (CORBA::Boolean etherealize_objects, CORBA::Boolean wait_for_completion ACE_ENV_ARG_DECL) throw (CORBA::SystemException)
void | complete_destruction_i (ACE_ENV_SINGLE_ARG_DECL)
PortableServer::POAList * | the_children_i (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException)
PortableInterceptor::AdapterName * | adapter_name_i (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException)
void | adapter_state_changed (const PortableInterceptor::ObjectReferenceTemplateSeq &seq_obj_ref_template, PortableInterceptor::AdapterState state ACE_ENV_ARG_DECL) throw (CORBA::SystemException)
void | add_ior_component (TAO_MProfile &mprofile, const IOP::TaggedComponent &component ACE_ENV_ARG_DECL) throw (CORBA::SystemException)
| Add the given tagged component to all profiles.
void | add_ior_component_to_profile (TAO_MProfile &mprofile, const IOP::TaggedComponent &component, IOP::ProfileId profile_id ACE_ENV_ARG_DECL) throw (CORBA::SystemException)
PortableServer::ServantManager_ptr | get_servant_manager_i (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
void | set_servant_manager_i (PortableServer::ServantManager_ptr imgr ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
PortableServer::Servant | get_servant_i (ACE_ENV_SINGLE_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::NoServant, PortableServer::POA::WrongPolicy)
void | set_servant_i (PortableServer::Servant servant ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
void | imr_notify_startup (ACE_ENV_SINGLE_ARG_DECL)
void | imr_notify_shutdown (void)
CORBA::Object_ptr | invoke_key_to_object (ACE_ENV_SINGLE_ARG_DECL)
CORBA::Object_ptr | key_to_object (const TAO::ObjectKey &key, const char *type_id, TAO_ServantBase *servant, CORBA::Boolean collocated, CORBA::Short priority ACE_ENV_ARG_DECL)
virtual TAO_Stub * | key_to_stub_i (const TAO::ObjectKey &key, const char *type_id, CORBA::Short priority ACE_ENV_ARG_DECL)
TAO_Stub * | create_stub_object (const TAO::ObjectKey &object_key, const char *type_id, CORBA::PolicyList *policy_list, TAO_Acceptor_Filter *filter, TAO_Acceptor_Registry &acceptor_registry ACE_ENV_ARG_DECL)
int | is_servant_in_map (PortableServer::Servant servant, int &wait_occurred_restart_call)
int | is_user_id_in_map (const PortableServer::ObjectId &user_id, CORBA::Short priority, int &priorities_match, int &wait_occurred_restart_call)
PortableServer::ObjectId * | activate_object_i (PortableServer::Servant p_servant, CORBA::Short priority, int &wait_occurred_restart_call ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::WrongPolicy)
void | activate_object_with_id_i (const PortableServer::ObjectId &id, PortableServer::Servant p_servant, CORBA::Short priority, int &wait_occurred_restart_call ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::ObjectAlreadyActive, PortableServer::POA::WrongPolicy)
void | deactivate_all_objects_i (CORBA::Boolean etherealize_objects ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
void | deactivate_all_objects_i (CORBA::Boolean etherealize_objects, CORBA::Boolean wait_for_completion ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
void | wait_for_completions (CORBA::Boolean wait_for_completion ACE_ENV_ARG_DECL)
void | check_poa_manager_state (ACE_ENV_SINGLE_ARG_DECL)
void | deactivate_object_i (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
void | cleanup_servant (TAO_Active_Object_Map::Map_Entry *active_object_map_entry ACE_ENV_ARG_DECL)
void | deactivate_map_entry (TAO_Active_Object_Map::Map_Entry *active_object_map_entry ACE_ENV_ARG_DECL)
CORBA::Object_ptr | create_reference_i (const char *intf, CORBA::Short priority ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | create_reference_with_id_i (const PortableServer::ObjectId &oid, const char *intf, CORBA::Short priority ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | servant_to_id_i (PortableServer::Servant servant ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | servant_to_system_id (PortableServer::Servant p_servant, CORBA::Short &priority ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
PortableServer::ObjectId * | servant_to_system_id_i (PortableServer::Servant p_servant, CORBA::Short &priority ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
PortableServer::Servant | reference_to_servant_i (CORBA::Object_ptr reference ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | servant_to_reference_i (PortableServer::Servant p_servant ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)
PortableServer::Servant | id_to_servant_i (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
CORBA::Object_ptr | id_to_reference_i (const PortableServer::ObjectId &oid ACE_ENV_ARG_DECL) throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)
void | establish_components (ACE_ENV_SINGLE_ARG_DECL)
void | components_established (PortableInterceptor::IORInfo_ptr info ACE_ENV_ARG_DECL)
int | delete_child (const String &child)
void | set_folded_name (void)
void | set_id (void)
TAO::ObjectKey * | create_object_key (const PortableServer::ObjectId &id)
int | is_poa_generated_id (const PortableServer::ObjectId &id)
TAO_SERVANT_LOCATION | locate_servant_i (const PortableServer::ObjectId &id, PortableServer::Servant &servant ACE_ENV_ARG_DECL)
PortableServer::Servant | locate_servant_i (const char *operation, const PortableServer::ObjectId &id, TAO_Object_Adapter::Servant_Upcall &servant_upcall, TAO_POA_Current_Impl &poa_current_impl, int &wait_occurred_restart_call ACE_ENV_ARG_DECL)
const TAO_Creation_Time & | creation_time (void)
CORBA::Boolean | persistent (void)
char | persistent_key_type (void)
CORBA::Boolean | system_id (void)
char | system_id_key_type (void)
CORBA::Boolean | root (void)
char | root_key_type (void)
void | outstanding_requests (CORBA::ULong new_outstanding_requests)
CORBA::ULong | increment_outstanding_requests (void)
CORBA::ULong | decrement_outstanding_requests (void)
TAO_SYNCH_RECURSIVE_MUTEX & | single_threaded_lock (void) const
## Static Protected Methods
int | parse_key (const TAO::ObjectKey &key, TAO_Object_Adapter::poa_name &poa_system_name, PortableServer::ObjectId &system_id, CORBA::Boolean &is_root, CORBA::Boolean &is_persistent, CORBA::Boolean &is_system_id, TAO_Temporary_Creation_Time &poa_creation_time)
TAO_POA_Policy_Set & | default_poa_policies (void)
char | persistent_key_char (void)
char | transient_key_char (void)
CORBA::ULong | persistent_key_type_length (void)
char | system_id_key_char (void)
char | user_id_key_char (void)
CORBA::ULong | system_id_key_type_length (void)
char | root_key_char (void)
char | non_root_key_char (void)
CORBA::ULong | root_key_type_length (void)
## Protected Attributes
String | name_
TAO_POA_Manager & | poa_manager_
IOP::TaggedComponentList | tagged_component_
IOP::TaggedComponentList | tagged_component_id_
ACE_Array_Base< IOP::ProfileId > | profile_id_array_
TAO_POA_Policy_Set | policies_
TAO_POA * | parent_
TAO_Active_Object_Map * | active_object_map_
TAO_Object_Adapter::poa_name | folded_name_
TAO_Object_Adapter::poa_name_var | system_name_
CORBA::OctetSeq | id_
TAO_ObjectReferenceTemplate * | def_ort_template_
PortableInterceptor::ObjectReferenceTemplate_var | ort_template_
PortableInterceptor::ObjectReferenceFactory_var | obj_ref_factory_
PortableInterceptor::AdapterState | adapter_state_
| Adapter can be accepting, rejecting etc.
TAO_POA_Cached_Policies | cached_policies_
int | delete_active_object_map_
PortableServer::AdapterActivator_var | adapter_activator_
PortableServer::ServantActivator_var | servant_activator_
PortableServer::ServantLocator_var | servant_locator_
PortableServer::ServantBase_var | default_servant_
ServerObject_i * | server_object_
| Implementation Repository Server Object.
int | use_imr_
| Flag for whether the ImR should be used or not.
CHILDREN | children_
ACE_Lock & | lock_
TAO_Creation_Time | creation_time_
TAO_ORB_Core & | orb_core_
TAO_Object_Adapter * | object_adapter_
CORBA::Boolean | cleanup_in_progress_
CORBA::Boolean | etherealize_objects_
CORBA::ULong | outstanding_requests_
TAO_SYNCH_CONDITION | outstanding_requests_condition_
CORBA::Boolean | wait_for_completion_pending_
CORBA::Boolean | waiting_destruction_
TAO_SYNCH_CONDITION | servant_deactivation_condition_
CORBA::ULong | waiting_servant_deactivation_
TAO_SYNCH_RECURSIVE_MUTEX * | single_threaded_lock_
CORBA::ULong | caller_key_to_object_
PortableServer::Servant | servant_for_key_to_object_
Key_To_Object_Params | key_to_object_params_
## Friends
class | TAO_Object_Adapter
class | TAO_Object_Adapter::Servant_Upcall
class | TAO_Object_Adapter::Non_Servant_Upcall
class | TAO_POA_Current_Impl
class | TAO_POA_Manager
class | TAO_RT_Collocation_Resolver
class | TAO_ObjectReferenceTemplate

## Detailed Description

Implementation of the PortableServer::POA interface.

Implementation of the PortableServer::POA interface.

## Member Typedef Documentation

typedef ACE_Hash_Map_Manager_Ex< ACE_CString, TAO_POA *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex > TAO_POA::CHILDREN`[protected]`

typedef ACE_CString TAO_POA::String

## Member Enumeration Documentation

anonymous enum

  | Enumeration values:
  TAO_OBJECTKEY_PREFIX_SIZE |

## Constructor & Destructor Documentation

TAO_POA::TAO_POA | ( | const String & | name,
|  | TAO_POA_Manager & | poa_manager,
|  | const TAO_POA_Policy_Set & | policies,
|  | TAO_POA * | parent,
|  | ACE_Lock & | lock,
|  | TAO_SYNCH_MUTEX & | thread_lock,
|  | TAO_ORB_Core & | orb_core,
|  | TAO_Object_Adapter *object_adapter | ACE_ENV_ARG_DECL
| ) |

TAO_POA::~TAO_POA | ( | void |  | ) | `[virtual]`

## Member Function Documentation

TAO_POA * TAO_POA::_tao_poa_downcast | ( | void |  | ) | `[virtual]`

| This method is used to downcast safely an instance of PortableServer::POA to an instance of TAO_POA when RTTI is not enabled. Reimplemented from PortableServer::POA.

PortableServer::ObjectId* TAO_POA::activate_object | ( | PortableServer::Servant p_servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ObjectId * TAO_POA::activate_object_i | ( | PortableServer::Servant | p_servant,
|  | CORBA::Short | priority,
|  | int &wait_occurred_restart_call | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::WrongPolicy)`[protected]`

void TAO_POA::activate_object_with_id | ( | const PortableServer::ObjectId & | id,
|  | PortableServer::Servant p_servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::ObjectAlreadyActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

void TAO_POA::activate_object_with_id_i | ( | const PortableServer::ObjectId & | id,
|  | PortableServer::Servant | p_servant,
|  | CORBA::Short | priority,
|  | int &wait_occurred_restart_call | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::ServantAlreadyActive, PortableServer::POA::ObjectAlreadyActive, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE TAO_Active_Object_Map & TAO_POA::active_object_map | ( | void |  | ) | const

ACE_INLINE PortableInterceptor::AdapterName * TAO_POA::adapter_name | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException)

| This method returns the adapter_name as a sequence of strings of length one or more or just a fixed name depending on the Object Adapter. Added wrt to ORT Spec.

PortableInterceptor::AdapterName * TAO_POA::adapter_name_i | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException)`[protected]`

| This method returns the adapter_name as a sequence of strings of length one or more or just a fixed name depending on the Object Adapter. Added wrt to ORT Spec.

void TAO_POA::adapter_state_changed | ( | const PortableInterceptor::ObjectReferenceTemplateSeq & | seq_obj_ref_template,
|  | PortableInterceptor::AdapterState state | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[protected]`

| Method to notify the IOR Interceptors when there is a state changed not related to POAManager.

void TAO_POA::add_ior_component | ( | TAO_MProfile & | mprofile,
|  | const IOP::TaggedComponent &component | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[protected]`

| Add the given tagged component to all profiles.

void TAO_POA::add_ior_component_to_profile | ( | TAO_MProfile & | mprofile,
|  | const IOP::TaggedComponent & | component,
|  | IOP::ProfileId profile_id | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[protected]`

| Add the given tagged component to all profiles matching the given ProfileId.

void TAO_POA::associate_reference_with_id | ( | CORBA::Object_ptr | ref,
|  | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw ( CORBA::SystemException, PortableServer::NotAGroupObject )`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE TAO_POA_Cached_Policies & TAO_POA::cached_policies | ( | void |  | ) |

| Accessor for cached POA policies.

void TAO_POA::check_for_valid_wait_for_completions | ( | const TAO_ORB_Core & | orb_core,
|  | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL
| ) | `[static]`

void TAO_POA::check_poa_manager_state | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

ACE_INLINE CORBA::Boolean TAO_POA::cleanup_in_progress | ( | void |  | ) |

void TAO_POA::cleanup_servant | ( | TAO_Active_Object_Map::Map_Entry *active_object_map_entry | ACE_ENV_ARG_DECL | ) | `[protected]`

CORBA::PolicyList * TAO_POA::client_exposed_policies | ( | CORBA::Short object_priority | ACE_ENV_ARG_DECL | ) | `[virtual]`

void TAO_POA::complete_destruction_i | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

void TAO_POA::components_established | ( | PortableInterceptor::IORInfo_ptr info | ACE_ENV_ARG_DECL | ) | `[protected]`

| Call the IORInterceptor::components_established() method on all registered IORInterceptors.

PortableServer::IdAssignmentPolicy_ptr TAO_POA::create_id_assignment_policy | ( | PortableServer::IdAssignmentPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ObjectId * TAO_POA::create_id_for_reference | ( | CORBA::Object_ptr the_ref | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw ( CORBA::SystemException, PortableServer::NotAGroupObject )`[virtual]`

| Implements PortableServer::POA.

PortableServer::IdUniquenessPolicy_ptr TAO_POA::create_id_uniqueness_policy | ( | PortableServer::IdUniquenessPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ImplicitActivationPolicy_ptr TAO_POA::create_implicit_activation_policy | ( | PortableServer::ImplicitActivationPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

PortableServer::LifespanPolicy_ptr TAO_POA::create_lifespan_policy | ( | PortableServer::LifespanPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

TAO::ObjectKey * TAO_POA::create_object_key | ( | const PortableServer::ObjectId & | id | ) | `[protected]`

ACE_INLINE PortableServer::POA_ptr TAO_POA::create_POA | ( | const char * | adapter_name,
|  | PortableServer::POAManager_ptr | poa_manager,
|  | const CORBA::PolicyList &policies | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)`[virtual]`

| Implements PortableServer::POA.

TAO_POA * TAO_POA::create_POA_i | ( | const String & | adapter_name,
|  | TAO_POA_Manager & | poa_manager,
|  | const TAO_POA_Policy_Set &policies | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)`[protected]`

PortableServer::POA_ptr TAO_POA::create_POA_i | ( | const char * | adapter_name,
|  | PortableServer::POAManager_ptr | poa_manager,
|  | const CORBA::PolicyList &policies | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::AdapterAlreadyExists, PortableServer::POA::InvalidPolicy)`[protected]`

ACE_INLINE CORBA::Object_ptr TAO_POA::create_reference | ( | const char *intf | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

CORBA::Object_ptr TAO_POA::create_reference_i | ( | const char * | intf,
|  | CORBA::Short priority | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE CORBA::Object_ptr TAO_POA::create_reference_with_id | ( | const PortableServer::ObjectId & | oid,
|  | const char *intf | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

CORBA::Object_ptr TAO_POA::create_reference_with_id_i | ( | const PortableServer::ObjectId & | oid,
|  | const char * | intf,
|  | CORBA::Short priority | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

PortableServer::RequestProcessingPolicy_ptr TAO_POA::create_request_processing_policy | ( | PortableServer::RequestProcessingPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ServantRetentionPolicy_ptr TAO_POA::create_servant_retention_policy | ( | PortableServer::ServantRetentionPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

TAO_Stub * TAO_POA::create_stub_object | ( | const TAO::ObjectKey & | object_key,
|  | const char * | type_id,
|  | CORBA::PolicyList * | policy_list,
|  | TAO_Acceptor_Filter * | filter,
|  | TAO_Acceptor_Registry &acceptor_registry | ACE_ENV_ARG_DECL
| ) | `[protected]`

PortableServer::ThreadPolicy_ptr TAO_POA::create_thread_policy | ( | PortableServer::ThreadPolicyValue value | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE const TAO_Creation_Time & TAO_POA::creation_time | ( | void |  | ) | `[protected]`

void TAO_POA::deactivate_all_objects_i | ( | CORBA::Boolean | etherealize_objects,
|  | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

void TAO_POA::deactivate_all_objects_i | ( | CORBA::Boolean etherealize_objects | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

void TAO_POA::deactivate_map_entry | ( | TAO_Active_Object_Map::Map_Entry *active_object_map_entry | ACE_ENV_ARG_DECL | ) | `[protected]`

ACE_INLINE void TAO_POA::deactivate_object | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

void TAO_POA::deactivate_object_i | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE CORBA::ULong TAO_POA::decrement_outstanding_requests | ( | void |  | ) | `[protected]`

TAO_POA_Policy_Set& TAO_POA::default_poa_policies | ( | void |  | ) | `[static, protected]`

| Access the list of default POA policies. This list is used as a prototype for creating new POA's. It should

int TAO_POA::delete_child | ( | const String & | child | ) | `[protected]`

ACE_INLINE void TAO_POA::destroy | ( | CORBA::Boolean | etherealize_objects,
|  | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

void TAO_POA::destroy_i | ( | CORBA::Boolean | etherealize_objects,
|  | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[protected]`

void TAO_POA::disassociate_reference_with_id | ( | CORBA::Object_ptr | ref,
|  | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw ( CORBA::SystemException, PortableServer::NotAGroupObject )`[virtual]`

| Implements PortableServer::POA.

void TAO_POA::establish_components | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

| This method calls IORInterceptor::establish_components() method on all registered IORInterceptors, and IORInterceptor::components_established() once the former is completed.

PortableServer::POA_ptr TAO_POA::find_POA | ( | const char * | adapter_name,
|  | CORBA::Boolean activate_it | ACE_ENV_ARG_DECL_WITH_DEFAULTS
| ) | throw (CORBA::SystemException, PortableServer::POA::AdapterNonExistent)`[virtual]`

| Implements PortableServer::POA.

TAO_POA * TAO_POA::find_POA_i | ( | const ACE_CString & | child_name,
|  | CORBA::Boolean activate_it | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::AdapterNonExistent)`[protected]`

ACE_INLINE const TAO_Object_Adapter::poa_name & TAO_POA::folded_name | ( | void |  | ) | const

ACE_INLINE PortableInterceptor::AdapterState TAO_POA::get_adapter_state | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) |

| Accessor methods to POA state. The POA can be in one of HOLDING, ACTIVE, DISCARDING, INACTIVE and NON_EXISTENT states.

ACE_INLINE PortableInterceptor::ObjectReferenceTemplate * TAO_POA::get_adapter_template | ( | void |  | ) |

| Accessor methods to ObjectReferenceTemplate.

ACE_INLINE PortableInterceptor::AdapterManagerId TAO_POA::get_manager_id | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException)

ACE_INLINE PortableInterceptor::ObjectReferenceFactory * TAO_POA::get_obj_ref_factory | ( | void |  | ) |

| Accessor methods to PortableInterceptor::ObjectReferenceFactory.

ACE_INLINE PortableServer::Servant TAO_POA::get_servant | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException, PortableServer::POA::NoServant, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::Servant TAO_POA::get_servant_i | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException, PortableServer::POA::NoServant, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE PortableServer::ServantManager_ptr TAO_POA::get_servant_manager | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ServantManager_ptr TAO_POA::get_servant_manager_i | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

CORBA::OctetSeq * TAO_POA::id | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE CORBA::Object_ptr TAO_POA::id_to_reference | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

CORBA::Object_ptr TAO_POA::id_to_reference_i | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE PortableServer::Servant TAO_POA::id_to_servant | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::Servant TAO_POA::id_to_servant_i | ( | const PortableServer::ObjectId &oid | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongPolicy)`[protected]`

void TAO_POA::imr_notify_shutdown | ( | void |  | ) | `[protected]`

void TAO_POA::imr_notify_startup | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

ACE_INLINE CORBA::ULong TAO_POA::increment_outstanding_requests | ( | void |  | ) | `[protected]`

CORBA::Object_ptr TAO_POA::invoke_key_to_object | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[protected]`

int TAO_POA::is_poa_generated_id | ( | const PortableServer::ObjectId & | id | ) | `[protected]`

int TAO_POA::is_servant_in_map | ( | PortableServer::Servant | servant,
|  | int & | wait_occurred_restart_call
| ) | `[protected]`

int TAO_POA::is_user_id_in_map | ( | const PortableServer::ObjectId & | user_id,
|  | CORBA::Short | priority,
|  | int & | priorities_match,
|  | int & | wait_occurred_restart_call
| ) | `[protected]`

CORBA::Object_ptr TAO_POA::key_to_object | ( | const TAO::ObjectKey & | key,
|  | const char * | type_id,
|  | TAO_ServantBase * | servant,
|  | CORBA::Boolean | collocated,
|  | CORBA::Short priority | ACE_ENV_ARG_DECL
| ) | `[protected]`

TAO_Stub * TAO_POA::key_to_stub | ( | const TAO::ObjectKey & | key,
|  | const char * | type_id,
|  | CORBA::Short priority | ACE_ENV_ARG_DECL
| ) |

| Create the correct stub, properly initialized with the attributes and policies attached to the current POA.

TAO_Stub * TAO_POA::key_to_stub_i | ( | const TAO::ObjectKey & | key,
|  | const char * | type_id,
|  | CORBA::Short priority | ACE_ENV_ARG_DECL
| ) | `[protected, virtual]`

PortableServer::Servant TAO_POA::locate_servant_i | ( | const char * | operation,
|  | const PortableServer::ObjectId & | id,
|  | TAO_Object_Adapter::Servant_Upcall & | servant_upcall,
|  | TAO_POA_Current_Impl & | poa_current_impl,
|  | int &wait_occurred_restart_call | ACE_ENV_ARG_DECL
| ) | `[protected]`

TAO_SERVANT_LOCATION TAO_POA::locate_servant_i | ( | const PortableServer::ObjectId & | id,
|  | PortableServer::Servant &servant | ACE_ENV_ARG_DECL
| ) | `[protected]`

ACE_INLINE ACE_Lock & TAO_POA::lock | ( | void |  | ) |

ACE_INLINE const ACE_CString & TAO_POA::name | ( | void |  | ) | const

ACE_INLINE char TAO_POA::name_separator | ( | void |  | ) | `[static]`

ACE_INLINE CORBA::ULong TAO_POA::name_separator_length | ( | void |  | ) | `[static]`

TAO_POA * TAO_POA::new_POA | ( | const String & | name,
|  | TAO_POA_Manager & | poa_manager,
|  | const TAO_POA_Policy_Set & | policies,
|  | TAO_POA * | parent,
|  | ACE_Lock & | lock,
|  | TAO_SYNCH_MUTEX & | thread_lock,
|  | TAO_ORB_Core & | orb_core,
|  | TAO_Object_Adapter *object_adapter | ACE_ENV_ARG_DECL
| ) | `[protected, virtual]`

| Template method for creating new POA's of this type.

ACE_INLINE char TAO_POA::non_root_key_char | ( | void |  | ) | `[static, protected]`

TAO_Object_Adapter & TAO_POA::object_adapter | ( | void |  | ) |

char * TAO_POA::ObjectId_to_string | ( | const PortableServer::ObjectId & | id | ) | `[static]`

CORBA::WChar * TAO_POA::ObjectId_to_wstring | ( | const PortableServer::ObjectId & | id | ) | `[static]`

ACE_INLINE TAO_ORB_Core & TAO_POA::orb_core | ( | void |  | ) | const

| Reimplemented from CORBA::Object.

ACE_INLINE void TAO_POA::outstanding_requests | ( | CORBA::ULong | new_outstanding_requests | ) | `[protected]`

ACE_INLINE CORBA::ULong TAO_POA::outstanding_requests | ( | void |  | ) | const

int TAO_POA::parse_ir_object_key | ( | const TAO::ObjectKey & | object_key,
|  | PortableServer::ObjectId & | user_id
| ) | `[static]`

int TAO_POA::parse_key | ( | const TAO::ObjectKey & | key,
|  | TAO_Object_Adapter::poa_name & | poa_system_name,
|  | PortableServer::ObjectId & | system_id,
|  | CORBA::Boolean & | is_root,
|  | CORBA::Boolean & | is_persistent,
|  | CORBA::Boolean & | is_system_id,
|  | TAO_Temporary_Creation_Time & | poa_creation_time
| ) | `[static, protected]`

ACE_INLINE CORBA::Boolean TAO_POA::persistent | ( | void |  | ) | `[protected]`

ACE_INLINE char TAO_POA::persistent_key_char | ( | void |  | ) | `[static, protected]`

ACE_INLINE char TAO_POA::persistent_key_type | ( | void |  | ) | `[protected]`

ACE_INLINE CORBA::ULong TAO_POA::persistent_key_type_length | ( | void |  | ) | `[static, protected]`

ACE_INLINE TAO_POA_Policy_Set & TAO_POA::policies | ( | void |  | ) |

| Accessor for POA policies.

PortableServer::ObjectId * TAO_POA::reference_to_id | ( | CORBA::Object_ptr reference | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::IDs * TAO_POA::reference_to_ids | ( | CORBA::Object_ptr the_ref | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw ( CORBA::SystemException, PortableServer::NotAGroupObject )`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE PortableServer::Servant TAO_POA::reference_to_servant | ( | CORBA::Object_ptr reference | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::Servant TAO_POA::reference_to_servant_i | ( | CORBA::Object_ptr reference | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ObjectNotActive, PortableServer::POA::WrongAdapter, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE CORBA::Boolean TAO_POA::root | ( | void |  | ) | `[protected]`

ACE_INLINE char TAO_POA::root_key_char | ( | void |  | ) | `[static, protected]`

ACE_INLINE char TAO_POA::root_key_type | ( | void |  | ) | `[protected]`

ACE_INLINE CORBA::ULong TAO_POA::root_key_type_length | ( | void |  | ) | `[static, protected]`

void TAO_POA::save_ior_component | ( | const IOP::TaggedComponent &component | ACE_ENV_ARG_DECL | ) |

| Store the given TaggedComponent for eventual insertion into all object reference profiles.

void TAO_POA::save_ior_component_and_profile_id | ( | const IOP::TaggedComponent & | component,
|  | IOP::ProfileId profile_id | ACE_ENV_ARG_DECL
| ) |

| Store the given TaggedComponent for eventual insertion into all object reference profiles with the given ProfileId.

PortableServer::ObjectId* TAO_POA::servant_to_id | ( | PortableServer::Servant p_servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

PortableServer::ObjectId * TAO_POA::servant_to_id_i | ( | PortableServer::Servant servant | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[protected]`

CORBA::Object_ptr TAO_POA::servant_to_reference | ( | PortableServer::Servant p_servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

CORBA::Object_ptr TAO_POA::servant_to_reference_i | ( | PortableServer::Servant p_servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE PortableServer::ObjectId * TAO_POA::servant_to_system_id | ( | PortableServer::Servant | p_servant,
|  | CORBA::Short &priority | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[protected]`

PortableServer::ObjectId * TAO_POA::servant_to_system_id_i | ( | PortableServer::Servant | p_servant,
|  | CORBA::Short &priority | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException, PortableServer::POA::ServantNotActive, PortableServer::POA::WrongPolicy)`[protected]`

CORBA::Policy * TAO_POA::server_protocol | ( | void |  | ) | `[virtual]`

void TAO_POA::set_adapter_template | ( | PortableInterceptor::ObjectReferenceTemplate *object_ref_template | ACE_ENV_ARG_DECL | ) |

void TAO_POA::set_folded_name | ( | void |  | ) | `[protected]`

void TAO_POA::set_id | ( | void |  | ) | `[protected]`

void TAO_POA::set_obj_ref_factory | ( | PortableInterceptor::ObjectReferenceFactory *current_factory | ACE_ENV_ARG_DECL | ) |

ACE_INLINE void TAO_POA::set_servant | ( | PortableServer::Servant servant | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)

void TAO_POA::set_servant_i | ( | PortableServer::Servant servant | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE void TAO_POA::set_servant_manager | ( | PortableServer::ServantManager_ptr imgr | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[virtual]`

| Implements PortableServer::POA.

void TAO_POA::set_servant_manager_i | ( | PortableServer::ServantManager_ptr imgr | ACE_ENV_ARG_DECL | ) | throw (CORBA::SystemException, PortableServer::POA::WrongPolicy)`[protected]`

ACE_INLINE TAO_SYNCH_RECURSIVE_MUTEX & TAO_POA::single_threaded_lock | ( | void |  | ) | const`[protected]`

PortableServer::ObjectId * TAO_POA::string_to_ObjectId | ( | const char * | string,
|  | int | size
| ) | `[static]`

PortableServer::ObjectId * TAO_POA::string_to_ObjectId | ( | const char * | id | ) | `[static]`

ACE_INLINE CORBA::Boolean TAO_POA::system_id | ( | void |  | ) | `[protected]`

ACE_INLINE char TAO_POA::system_id_key_char | ( | void |  | ) | `[static, protected]`

ACE_INLINE char TAO_POA::system_id_key_type | ( | void |  | ) | `[protected]`

ACE_INLINE CORBA::ULong TAO_POA::system_id_key_type_length | ( | void |  | ) | `[static, protected]`

ACE_INLINE const TAO_Object_Adapter::poa_name & TAO_POA::system_name | ( | void |  | ) | const

ACE_INLINE void TAO_POA::the_activator | ( | PortableServer::AdapterActivator_ptr adapter_activator | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)

ACE_INLINE PortableServer::AdapterActivator_ptr TAO_POA::the_activator | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE PortableServer::POAList * TAO_POA::the_children | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

PortableServer::POAList * TAO_POA::the_children_i | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | throw (CORBA::SystemException)`[protected]`

ACE_INLINE char * TAO_POA::the_name | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE PortableServer::POA_ptr TAO_POA::the_parent | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE PortableServer::POAManager_ptr TAO_POA::the_POAManager | ( | ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS |  | ) | throw (CORBA::SystemException)`[virtual]`

| Implements PortableServer::POA.

ACE_INLINE PortableServer::ThreadPolicyValue TAO_POA::thread_policy | ( | void |  | ) | const

| Accessor for the current thread policy of this POA.

ACE_INLINE void * TAO_POA::thread_pool | ( | void |  | ) | const`[virtual]`

ACE_INLINE char TAO_POA::transient_key_char | ( | void |  | ) | `[static, protected]`

ACE_INLINE char TAO_POA::user_id_key_char | ( | void |  | ) | `[static, protected]`

void TAO_POA::wait_for_completions | ( | CORBA::Boolean wait_for_completion | ACE_ENV_ARG_DECL | ) | `[protected]`

ACE_INLINE CORBA::Boolean TAO_POA::waiting_destruction | ( | void |  | ) | const

PortableServer::ObjectId * TAO_POA::wstring_to_ObjectId | ( | const CORBA::WChar * | id | ) | `[static]`

## Friends And Related Function Documentation

friend class TAO_Object_Adapter`[friend]`

friend class TAO_Object_Adapter::Non_Servant_Upcall`[friend]`

friend class TAO_Object_Adapter::Servant_Upcall`[friend]`

friend class TAO_ObjectReferenceTemplate`[friend]`

friend class TAO_POA_Current_Impl`[friend]`

friend class TAO_POA_Manager`[friend]`

friend class TAO_RT_Collocation_Resolver`[friend]`

## Member Data Documentation

TAO_Active_Object_Map* TAO_POA::active_object_map_`[protected]`

PortableServer::AdapterActivator_var TAO_POA::adapter_activator_`[protected]`

PortableInterceptor::AdapterState TAO_POA::adapter_state_`[protected]`

| Adapter can be accepting, rejecting etc.

TAO_POA_Cached_Policies TAO_POA::cached_policies_`[protected]`

CORBA::ULong TAO_POA::caller_key_to_object_`[protected]`

CHILDREN TAO_POA::children_`[protected]`

CORBA::Boolean TAO_POA::cleanup_in_progress_`[protected]`

TAO_Creation_Time TAO_POA::creation_time_`[protected]`

TAO_ObjectReferenceTemplate* TAO_POA::def_ort_template_`[protected]`

| Keep a copy of the pointer to the actual implementation around so that we can call some TAO-specific methods on it.

PortableServer::ServantBase_var TAO_POA::default_servant_`[protected]`

int TAO_POA::delete_active_object_map_`[protected]`

CORBA::Boolean TAO_POA::etherealize_objects_`[protected]`

TAO_Object_Adapter::poa_name TAO_POA::folded_name_`[protected]`

CORBA::OctetSeq TAO_POA::id_`[protected]`

Key_To_Object_Params TAO_POA::key_to_object_params_`[protected]`

ACE_Lock& TAO_POA::lock_`[protected]`

String TAO_POA::name_`[protected]`

PortableInterceptor::ObjectReferenceFactory_var TAO_POA::obj_ref_factory_`[protected]`

TAO_Object_Adapter* TAO_POA::object_adapter_`[protected]`

CORBA::Octet TAO_POA::objectkey_prefix`[static]`

| Initial value:
     {
      024,
      001,
      017,
      000
    }

TAO_ORB_Core& TAO_POA::orb_core_`[protected]`

| Reimplemented from CORBA::Object.

PortableInterceptor::ObjectReferenceTemplate_var TAO_POA::ort_template_`[protected]`

CORBA::ULong TAO_POA::outstanding_requests_`[protected]`

TAO_SYNCH_CONDITION TAO_POA::outstanding_requests_condition_`[protected]`

TAO_POA* TAO_POA::parent_`[protected]`

TAO_POA_Manager& TAO_POA::poa_manager_`[protected]`

TAO_POA_Policy_Set TAO_POA::policies_`[protected]`

ACE_Array_Base<IOP::ProfileId> TAO_POA::profile_id_array_`[protected]`

PortableServer::ServantActivator_var TAO_POA::servant_activator_`[protected]`

TAO_SYNCH_CONDITION TAO_POA::servant_deactivation_condition_`[protected]`

PortableServer::Servant TAO_POA::servant_for_key_to_object_`[protected]`

PortableServer::ServantLocator_var TAO_POA::servant_locator_`[protected]`

ServerObject_i* TAO_POA::server_object_`[protected]`

| Implementation Repository Server Object.

TAO_SYNCH_RECURSIVE_MUTEX* TAO_POA::single_threaded_lock_`[protected]`

TAO_Object_Adapter::poa_name_var TAO_POA::system_name_`[protected]`

IOP::TaggedComponentList TAO_POA::tagged_component_`[protected]`

IOP::TaggedComponentList TAO_POA::tagged_component_id_`[protected]`

int TAO_POA::use_imr_`[protected]`

| Flag for whether the ImR should be used or not.

CORBA::Boolean TAO_POA::wait_for_completion_pending_`[protected]`

CORBA::Boolean TAO_POA::waiting_destruction_`[protected]`

CORBA::ULong TAO_POA::waiting_servant_deactivation_`[protected]`

The documentation for this class was generated from the following files:

- POA.h
- POA.cpp
- POA.i